<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procartz Enterprise 3.8                                       ***
  ***      File:  block_products_breadcrumb.php                            ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procartz.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/
                           

function products_breadcrumb($block_name)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings;
	global $category_id, $is_reviews;


	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");

	$t->set_file("block_body", "block_breadcrumb.html");

	$manf = get_param("manf");
	$user = get_param("user");
	$item_id = get_param("item_id");
	$category_id = get_param("category_id");
	$search_category_id = get_param("search_category_id");
	if(strlen($search_category_id)) {
		$category_id = $search_category_id;
	}
	if (!strlen($category_id) && strlen($item_id)) {
		$category_id = get_db_value("SELECT category_id FROM " . $table_prefix . "items_categories WHERE item_id=" . $db->tosql($item_id, INTEGER));
	}

	$t->set_var("index_href", "index.php");
	$t->set_var("HOME_PAGE_TITLE", HOME_PAGE_TITLE);

	if ($category_id) {
		$current_id = $category_id;
		$sql  = " SELECT category_id, category_name, friendly_url, parent_category_id ";
		$sql .= " FROM " . $table_prefix . "categories";
		$sql .= " WHERE category_id=";
		while ($current_id)
		{
			$db->query($sql . $db->tosql($current_id, INTEGER));
			if($db->next_record()) {
				$category_name = $db->f("category_name");
				$category_name = get_translation($category_name);
				$friendly_url = $db->f("friendly_url");
				if ($friendly_urls && $friendly_url) {
					$tree_url = $friendly_url . $friendly_extension;
				} else {
					$tree_url = "products.php?category_id=". $current_id;
				}

				$t->set_var("tree_url", $tree_url);
				$t->set_var("tree_title", $category_name);
				$t->rparse("tree");
				$current_id= $db->f("parent_category_id");
			} else {
				$current_id = "0";
			}
		}
	}

	$t->set_var("tree_url", "products.php");
	$t->set_var("tree_title", PRODUCTS_TITLE);
	$t->rparse("tree");

	if (strlen($manf)) {
		$sql = "SELECT manufacturer_name, friendly_url FROM " . $table_prefix . "manufacturers WHERE manufacturer_id=" . $db->tosql($manf, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$friendly_url = $db->f("friendly_url");
			if ($friendly_urls && $friendly_url) {
				$tree_url = $friendly_url . $friendly_extension;
				if ($category_id) {
					$tree_url .= "?category_id=" . urlencode($category_id);
				}
			} else if ($category_id) {
				$tree_url = "products.php?category_id=" . urlencode($category_id) . "&manf=" . urlencode($manf);
			} else {
				$tree_url = "products.php?manf=" . urlencode($manf);
			}

			$t->set_var("tree_url", $tree_url);
			$t->set_var("tree_title", $db->f("manufacturer_name"));
			$t->parse("tree", true);
		}
	}

	if (strlen($user)) {
		$sql = "SELECT company_name, name, login, friendly_url FROM " . $table_prefix . "users WHERE user_id=" . $db->tosql($user, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$company_name = $db->f("company_name");
			if (!strlen($company_name)) {
				$company_name = $db->f("name");
			}
			if (!strlen($company_name)) {
				$company_name = $db->f("login");
			}
			$friendly_url = $db->f("friendly_url");
			if ($friendly_urls && $friendly_url) {
				$tree_url = $friendly_url . $friendly_extension;
			} else {
				$tree_url = "user_list.php?user=" . urlencode($user);
			}

			$t->set_var("tree_url", $tree_url);
			$t->set_var("tree_title", $company_name);
			$t->parse("tree", true);
		}
	}

	// check search
	$ps_parameters = array();
	$search_params = array(
		"search_string", "lprice", "hprice", "lweight", "hweight"
	);
	for ($si = 0; $si < sizeof($search_params); $si++) {
		$search_param = $search_params[$si];
		$param_value  = get_param($search_param);
		if (strlen($param_value)) {
			$ps_parameters[$search_param] = $param_value;
		}
	}

	$pq = get_param("pq");
	$fq = get_param("fq");
	if ($pq > 0) {
		for($pi = 1; $pi <= $pq; $pi++) {
			$property_name = get_param("pn_" . $pi);
			$property_value = get_param("pv_" . $pi);
			if (strlen($property_name) && strlen($property_value)) {
				$ps_parameters["pq"] = $pq;
				$ps_parameters["pn_" . $pi] = $property_name;
				$ps_parameters["pv_" . $pi] = $property_value;
			}
		}
	}
	if ($fq > 0) {
		for($fi = 1; $fi <= $fq; $fi++) {
			$feature_name = get_param("fn_" . $fi);
			$feature_value = get_param("fv_" . $fi);
			if (strlen($feature_name) && strlen($feature_value)) {
				$ps_parameters["fq"] = $fq;
				$ps_parameters["fn_" . $fi] = $feature_name;
				$ps_parameters["fv_" . $fi] = $feature_value;
			}
		}
	}

	// Proceed products search parameters
	if (sizeof($ps_parameters) > 0) {
		$ps_parameters["s_tit"] = get_param("s_tit");
		$ps_parameters["s_cod"] = get_param("s_cod");
		$ps_parameters["s_sds"] = get_param("s_sds");
		$ps_parameters["s_fds"] = get_param("s_fds");
		$ps_parameters["category_id"] = $category_id;
		$ps_parameters["manf"] = get_param("manf");
		$query_string = get_query_string($ps_parameters, "", "", false);
		$tree_url = "products_search.php" . $query_string;
		$tree_title = SEARCH_RESULTS_MSG;
		$t->set_var("tree_url", $tree_url);
		$t->set_var("tree_title", $tree_title);
		$t->parse("tree", true);
	}

	if (strlen($item_id)) {
		$ps_parameters["category_id"] = get_param("category_id");
		$sql = "SELECT item_name, friendly_url FROM " . $table_prefix . "items WHERE item_id=" . $db->tosql($item_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$item_name = get_translation($db->f("item_name"));
			$friendly_url = $db->f("friendly_url");
			if ($friendly_urls && $friendly_url) {
				$query_string = get_query_string($ps_parameters, "", "", false);
				$tree_url = $friendly_url . $friendly_extension . $query_string;
			} else {
				$ps_parameters["item_id"] = $item_id;
				$query_string = get_query_string($ps_parameters, "", "", false);
				$tree_url = "product_details.php" . $query_string;
			}

			$t->set_var("tree_url", $tree_url);
			$t->set_var("tree_title", $item_name);
			$t->parse("tree", true);
		}
	}
	if ($is_reviews) {
		$query_string = get_query_string($ps_parameters, "", "", false);
		$tree_url = "reviews.php" . $query_string;
		$t->set_var("tree_url", $tree_url);
		$t->set_var("tree_title", REVIEWS_MSG);
		$t->parse("tree", true);
	}

	$t->parse("block_body", false);
	$t->parse($block_name, true);

}

?>