<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procartz Enterprise 3.8                                       ***
  ***      File:  block_products_recently.php                              ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procartz.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function products_recently_viewed($block_name)
{
	global $t;
	global $db, $table_prefix;
	global $settings;
	global $category_id;
	global $page_settings;
	global $currency_left, $currency_right, $currency_rate;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$discount_type = get_session("session_discount_type");
	$discount_amount = get_session("session_discount_amount");

	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");
	$recent_records = get_setting_value($page_settings, "recent_records", 5);
	$display_products = get_setting_value($settings, "display_products", 0);
	$user_id = get_session("session_user_id");		

	$t->set_file("block_body", "block_recently_viewed.html");
	$t->set_var("compare_href",          "compare.php");
	$t->set_var("compare_name",          "products_recent");

	$t->set_var("top_category_name",     PRODUCTS_TITLE);
	$t->set_var("RECENTLY_VIEWED_TITLE", RECENTLY_VIEWED_TITLE);
	$t->set_var("COMPARE_MSG",           COMPARE_MSG);
	$t->set_var("recently_viewed_items",  "");

	$recently_viewed = get_session("session_recently_viewed");
	if(is_array($recently_viewed)) {
		$recent_number = 0;
		foreach ($recently_viewed as $key => $recent_info) {
			$recent_number++;
			if ($recent_number > $recent_records) {
				break;
			}
			list($item_id, $item_type_id, $item_name, $friendly_url, $recent_price, $buying_price, $tax_free, $is_compared) = $recently_viewed[$key];

			if ($friendly_urls && $friendly_url) {
				$details_href = $friendly_url . $friendly_extension;
			} else {
				$details_href = "product_details.php?item_id=".urlencode($item_id);
			}

			$t->set_var("item_id", $item_id);
			$t->set_var("top_position", $recent_number);
			$t->set_var("top_name", get_translation($item_name));
			$t->set_var("details_href", $details_href);
			if ($is_compared) {
				$t->parse("recent_compare", false);
			} else {
				$t->set_var("recent_compare", "");
			}

			if ($display_products != 2 || strlen($user_id)) {
				$recent_price = $recent_price * $currency_rate;

				set_tax_price($item_id, $item_type_id, $recent_price, 0, $tax_free, "top_value", "", "top_tax_price", false);

				$t->sparse("top_value_block", false);
			}



			$t->parse("recently_viewed_items", true);
		}
		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>