<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procartz Enterprise 3.8                                       ***
  ***      File:  user_select.php                                          ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procartz.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./includes/common.php");
	include_once ("./includes/sorter.php");
	include_once ("./messages/".$language_code."/download_messages.php");

	check_user_session();

	$t = new VA_Template($settings["templates_dir"]);
	$t->set_file("main","user_select.html");
	$t->set_var("css_file", "styles/" . $settings["style_name"] . ".css");

	$t->set_var("user_upload_href", "user_upload.php");
	$t->set_var("user_select_href", "user_select.php");

	$id = get_param("id");
	$operation = get_param("operation");
	$filetype = get_param("filetype");
	$control_name = get_param("control_name");
	$fid = get_param("fid");
	$control_name = get_param("control_name");
	$search_file = get_param("sf");

	if ($operation == "delete" && strlen($id)) {
		$sql  = " SELECT file_id, file_name, file_path FROM " . $table_prefix . "users_files ";
		$sql .= " WHERE user_id=" . $db->tosql(get_session("session_user_id"), INTEGER);
		$sql .= " AND file_type=" . $db->tosql($filetype, TEXT);
		$sql .= " AND file_id=" . $db->tosql($id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$file_path = $db->f("file_path");
			// delete from disk
			$file_deleted = unlink($file_path);
			if ($file_deleted) {
				// delete from table
				$db->query(" DELETE FROM " . $table_prefix . "users_files WHERE file_id=" . $db->tosql($id, INTEGER));
			}
		}
	}

	$downloads_dir = ""; 
	if ($filetype == "downloads") {
		$download_info = array();
		$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='download_info'";
		$db->query($sql);
		while($db->next_record()) {
			$download_info[$db->f("setting_name")] = $db->f("setting_value");
		}
		$downloads_dir = get_setting_value($download_info, "downloads_users_dir", "./");
		if (!preg_match("/\/|\\$/", $downloads_dir)) { $downloads_dir .= "/"; }
	}

	$t->set_var("sf", $search_file);

	$s = new VA_Sorter($settings["templates_dir"], "sorter_img.html", "user_select.php");
	$s->set_parameters(false, true, true, true);
	$s->set_default_sorting("1", "asc");
	$s->set_sorter("Filename", "sorter_file_name", "1", "file_name");

	$t->set_var("filetype", $filetype);
	$t->set_var("control_name", $control_name);
	$t->set_var("fid", $fid);

	if ($filetype == "article_small") {
		$files_dir = "./images/articles/small/";
	} else if ($filetype == "article_large") {
		$files_dir = "./images/articles/large/";
	} else if ($filetype == "ad_small") {
		$files_dir = "./images/ads/small/";
	} else if ($filetype == "ad_large") {
		$files_dir = "./images/ads/large/";
	} else if ($filetype == "personal_image") {
		$files_dir = "./images/users/";
	} else if ($filetype == "option_image") {
		$files_dir = "./images/options/";
	} else if ($filetype == "product_small") {
		$files_dir = "./images/products/small/";
	} else if ($filetype == "product_large") {
		$files_dir = "./images/products/large/";
	} else if ($filetype == "product_super") {
		$files_dir = "./images/products/super/";
	} else if ($filetype == "downloads") {
		$files_dir = $downloads_dir;
	} else {
		echo "Sorry, unknown file type";
		exit;
	}

	$files_total = 0;

	$sql  = " SELECT file_id, file_name, file_path FROM " . $table_prefix . "users_files ";
	$sql .= " WHERE user_id=" . $db->tosql(get_session("session_user_id"), INTEGER);
	$sql .= " AND file_type=" . $db->tosql($filetype, TEXT);
	if (strlen($search_file)) {
		$sql .= " AND file_path LIKE '%" . $db->tosql($search_file, TEXT, false, false) . "%' ";
	}
	$sql .= $s->order_by;
	$db->query($sql);
	if ($db->next_record()) {
		$user_delete_file_url = "user_select.php?filetype=" . urlencode($filetype);
		if (strlen($search_file)) {
			$user_delete_file_url .= "&sf=" . urlencode($search_file);
		}
		if (strlen($control_name)) {
			$user_delete_file_url .= "&control_name=" . urlencode($control_name);
		}
		if (strlen($fid)) {
			$user_delete_file_url .= "&fid=" . urlencode($fid);
		}
		do {
			$files_total++;
			$file_id = $db->f("file_id");
			$file_path = $db->f("file_path");
			$file_name = basename($file_path);
			if ($filetype != "option_image") {
				$file_path_js = str_replace("'", "\\'", $file_path);
			} else {
				$file_path_js = str_replace("'", "\\'", $file_name);
			}
			$t->set_var("file_name", $file_name);
			$t->set_var("file_path_js", $file_path_js);
			$t->set_var("user_delete_file_url", $user_delete_file_url . "&operation=delete&id=" . $file_id);

			$t->parse("file_row", true);
		} while ($db->next_record());

		$t->set_var("no_files", "");
		$t->parse("files", false);
	}
	else
	{
		$t->parse("no_files", false);
		$t->set_var("files", "");
	}

	if (!$files_total && !strlen($search_file)) {	
		$t->set_var("search_files", "");
	} else {
		$t->parse("search_files", false);
	}

	$t->pparse("main");

?>