<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procartz Enterprise 3.8                                       ***
  ***      File:  user_upload.php                                          ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procartz.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./includes/common.php");
	include_once ("./messages/".$language_code."/download_messages.php");

	$filetype = get_param("filetype");

	$display_products = get_setting_value($settings, "display_products", 0);
	if ($display_products == 1 || $display_products == 2 || $filetype != "option_image") {
		check_user_session();
	}

  $t = new VA_Template($settings["templates_dir"]);
  $t->set_file("main","user_upload.html");
	$t->set_var("user_upload_href", "user_upload.php");
	$t->set_var("css_file", "styles/" . $settings["style_name"] . ".css");
	$t->set_var("CHARSET", CHARSET);
	$t->set_var("CLOSE_WINDOW_MSG", CLOSE_WINDOW_MSG);
	$t->set_var("UPLOAD_TITLE",     UPLOAD_TITLE);
	$t->set_var("UPLOAD_BUTTON",    UPLOAD_BUTTON);
	$upload_msg = str_replace("{button_name}", UPLOAD_BUTTON, UPLOAD_SELECT_MSG);
	$t->set_var("UPLOAD_SELECT_MSG", $upload_msg);

	$user_id = get_session("session_user_id");
	$type = get_session("session_user_type_id");
	$filetype = get_param("filetype");
	$fid = get_param("fid");
	$control_name = get_param("control_name");
	$operation = get_param("operation");

	if (!strlen($type)) {
		$type = get_db_value("SELECT type_id FROM " . $table_prefix . "user_types WHERE is_default=1");
	}

	$downloads_dir = ""; $files_regexp = "";
	if ($filetype == "downloads") {
		$download_info = array();
		$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='download_info'";
		$db->query($sql);
		while($db->next_record()) {
			$download_info[$db->f("setting_name")] = $db->f("setting_value");
		}
		$downloads_dir = get_setting_value($download_info, "downloads_users_dir", "./");
		if (!preg_match("/\/|\\$/", $downloads_dir)) { $downloads_dir .= "/"; }
		$downloads_mask = get_setting_value($download_info, "downloads_users_mask", "");
		if ($downloads_mask) {
			$files_regexp = preg_replace("/\s/", "", $downloads_mask);
			$s = array("\\","^","\$",".","[","]","|","(",")","+","{","}");
			$r = array("\\\\","\\^","\\\$","\\.","\\[","\\]","\\|","\\(","\\)","\\+","\\{","\\}");
			$files_regexp = str_replace($s, $r, $files_regexp);
			$files_regexp = str_replace(array(",", ";", "*", "?"), array(")|(", ")|(", ".*", "."), $files_regexp);
			$files_regexp = "/^((" . $files_regexp . "))$/i";
		}
	}

	$errors = "";

	if($operation == "1")
	{
		if (isset($_FILES)) {
			$tmp_name = $_FILES["newfile"]["tmp_name"];
			$filename = $_FILES["newfile"]["name"];
			$filesize = $_FILES["newfile"]["size"];
			$upload_error = isset($_FILES["newfile"]["error"]) ? $_FILES["newfile"]["error"] : "";
		} else {
			$tmp_name = $HTTP_POST_FILES["newfile"]["tmp_name"];
			$filename = $HTTP_POST_FILES["newfile"]["name"];
			$filesize = $HTTP_POST_FILES["newfile"]["size"];
			$upload_error = isset($HTTP_POST_FILES["newfile"]["error"]) ? $HTTP_POST_FILES["newfile"]["error"] : "";
		}

		if ($upload_error == 1) {
			$errors = "The uploaded file exceeds the max filesize directive.";
		} else if ($upload_error == 2) {
			$errors = "The uploaded file exceeds the max filesize parameter.";
		} else if ($upload_error == 3) {
			$errors = "The uploaded file was only partially uploaded.";
		} else if ($upload_error == 4) {
			$errors = UPLOAD_SELECT_ERROR;
		} else if ($upload_error == 6) {
			$errors = "Missing a temporary folder.";
		} else if ($upload_error == 7) {
			$errors = "Failed to write file to disk.";
		} else if ($tmp_name == "none" || !strlen($tmp_name)) {
			$errors = UPLOAD_SELECT_ERROR;
		} else if (strlen($files_regexp)) {
			if (!preg_match($files_regexp, $filename)) {
				$errors = UPLOAD_FORMAT_ERROR;
			}
		} else if (!(preg_match("/((.gif)|(.jpg)|(.jpeg)|(.bmp)|(.tiff)|(.tif)|(.png)|(.ico)|(.doc)|(.txt)|(.rtf)|(.pdf))$/i", $filename)) ) {
			$errors = UPLOAD_FORMAT_ERROR;
		}

		$max_image_width = 0; $max_image_height = 0; $max_image_size = 0;
		if(!strlen($errors) && ($filetype == "ad_small") || $filetype == "ad_large") {
			$ads_images = array();
			$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type=" . $db->tosql("ads_images", TEXT);
			$db->query($sql);
			while($db->next_record()) {
				$ads_images[$db->f("setting_name")] = $db->f("setting_value");
			}
			if ($filetype == "ad_small") {
				$max_image_size = get_setting_value($ads_images, "image_small_size", 16384);
				$max_image_width = get_setting_value($ads_images, "image_small_width", 100);
				$max_image_height = get_setting_value($ads_images, "image_small_height", 100);
			} else if ($filetype == "ad_large") {
				$max_image_size = get_setting_value($ads_images, "image_large_size", 204800);
				$max_image_width = get_setting_value($ads_images, "image_large_width", 800);
				$max_image_height = get_setting_value($ads_images, "image_large_height", 600);
			} else if ($filetype == "option_image") {
				$max_image_size = 204800;
				$max_image_width = 800;
				$max_image_height = 600;
			}
			
			if ($filesize > $max_image_size) {
				$errors = str_replace("{filesize}", intval($max_image_size / 1024) . "kb", UPLOAD_SIZE_ERROR);
			} 
		}

		if(!strlen($errors) && $filetype == "personal_image") {
			$user_profile = array();
			$sql  = " SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings ";
			$sql .= " WHERE setting_type=" . $db->tosql("user_profile_" . $type, TEXT) . " AND setting_name LIKE 'personal_image_%'";
			$db->query($sql);
			while($db->next_record()) {
				$user_profile[$db->f("setting_name")] = $db->f("setting_value");
			}
			$max_image_size = get_setting_value($user_profile, "personal_image_size", 16384);
			$max_image_width = get_setting_value($user_profile, "personal_image_width", 100);
			$max_image_height = get_setting_value($user_profile, "personal_image_height", 100);
			if (filesize($tmp_name) > $max_image_size) {
				$errors = str_replace("{filesize}", intval($max_image_size / 1024) . "kb", UPLOAD_SIZE_ERROR);
			} else {
				$image_params = @getimagesize($tmp_name);
				if($image_params[0] > $max_image_width || $image_params[1] > $max_image_height) {
					$errors = str_replace("{dimension}", $max_image_width . "x" . $max_image_height, UPLOAD_DIMENSION_ERROR);
				}
			}

		}

		if(!strlen($errors))
		{
			if ($filetype == "article_small") {
				$filepath = "./images/articles/small/";
			} else if ($filetype == "article_large") {
				$filepath = "./images/articles/large/";
			} else if ($filetype == "ad_small") {
				$filepath = "./images/ads/small/";
			} else if ($filetype == "ad_large") {
				$filepath = "./images/ads/large/";
			} else if ($filetype == "personal_image") {
				$filepath = "./images/users/";
			} else if ($filetype == "option_image") {
				$filepath = "./images/options/";
			} else if ($filetype == "product_small") {
				$filepath = "./images/products/small/";
			} else if ($filetype == "product_large") {
				$filepath = "./images/products/large/";
			} else if ($filetype == "product_super") {
				$filepath = "./images/products/super/";
			} else if ($filetype == "downloads") {
				$filepath = $downloads_dir;
			} else {
				echo "Sorry, unknown file type";
				exit;
			}

			$new_filename = $filename;
			$file_index = 0;
			while (file_exists($filepath . $new_filename)) {
				$file_index++;
				$delimiter_pos = strpos($filename, ".");
				if($delimiter_pos) {
					$new_filename = substr($filename, 0, $delimiter_pos) . "_" . $file_index . substr($filename, $delimiter_pos);
				} else {
					$new_filename = $index . "_" . $filename;
				}
			}

			if(!move_uploaded_file($tmp_name, $filepath . $new_filename)) {
				$errors = UPLOAD_CREATE_ERROR;
			} else {
				// change permissions to uploaded file
				chmod($filepath . $new_filename, 0766);
				if ($max_image_width > 0) {
					$image_params = @getimagesize($filepath . $new_filename);
					if($image_params[0] > $max_image_width || $image_params[1] > $max_image_height) {
						$errors = str_replace("{dimension}", $max_image_width . "x" . $max_image_height, UPLOAD_DIMENSION_ERROR);
					}
				}

				if (strlen($errors)) {
					unlink($filepath . $new_filename);
				} else {
					$user_path = preg_replace("/^\.\//", "", $filepath);
					$filename_js = str_replace("'", "\\'", $new_filename);
					if ($filetype != "option_image") {
						$filename_js = $user_path . $filename_js;
					}
					$t->set_var("filename", $new_filename);
					$t->set_var("filename_js", $filename_js);

					$uploaded_msg = str_replace("{filename}", $new_filename, UPLOADED_FILE_MSG);
					$t->set_var("UPLOADED_FILE_MSG", $uploaded_msg);

					if (get_session("session_user_id")) {
						$sql  = " INSERT INTO " . $table_prefix . "users_files (user_id, file_type, file_name, file_path) VALUES (";
						$sql .= $db->tosql(get_session("session_user_id"), INTEGER) . ", ";
						$sql .= $db->tosql($filetype, TEXT) . ", ";
						$sql .= $db->tosql($filename, TEXT) . ", ";
						$sql .= $db->tosql($user_path . $new_filename, TEXT) . ") ";
						$db->query($sql);
					}
				}
			}
		} else {
			if (strlen($tmp_name)) {
				unlink($tmp_name);
			}
		}
	}

	if(strlen($errors))
	{
		$t->set_var("after_upload", "");
		$t->set_var("errors_list", $errors);
		$t->parse("errors", false);
	}
	else
	{
		$t->set_var("errors", "");
	}

	$t->set_var("filetype", htmlspecialchars($filetype));
	$t->set_var("type", htmlspecialchars($type));
	$t->set_var("fid", htmlspecialchars($fid));
	$t->set_var("control_name", htmlspecialchars($control_name));

	if($operation == "1" && !strlen($errors))
	{
		$t->set_var("before_upload", "");
		$t->parse("after_upload", false);
	}
	else
	{
		$t->parse("before_upload", false);
		$t->set_var("after_upload", "");
	}

	$t->pparse("main");

?>